// Ceres Decoder

module CERDEC ( BCLK, DIN, AA, W_DIPSW, CERES_ON, GINT, ICU_Q, 
				SCSI_Q, AM9519A_Q, M3001_Q, DP8473_Q, SC2692_Q, Z85C30_Q, VECTOR_Q, CERES_Q, INT_N );

	input			BCLK;
	input	 [7:0]	DIN;
	input  [14:12]	AA;
	input			W_DIPSW;
	input			CERES_ON;
	input			GINT;
	input	[32:0]	ICU_Q;
	input	 [7:0]	SCSI_Q,AM9519A_Q,M3001_Q,DP8473_Q,SC2692_Q,Z85C30_Q,VECTOR_Q;

	output	reg	[31:0]	CERES_Q;
	output			INT_N;
	
	reg		 [7:0]	dip_sw;
	
	always @(*)
		case (AA)
		  3'd0 : CERES_Q = {24'd0,SCSI_Q};
		  3'd1 : CERES_Q = {24'd0,AM9519A_Q};	// Interrupt Control Unit
		  3'd2 : CERES_Q = {24'd0,M3001_Q};		// RTC
		  3'd3 : CERES_Q = {24'd0,DP8473_Q};	// Floppy
		  3'd4 : CERES_Q = {24'd0,SC2692_Q};	// Channel A = Keyboard
		  3'd5 : CERES_Q = {24'd0,Z85C30_Q};	// Channel B = Mouse
		  3'd6 : CERES_Q = {24'd0,dip_sw};
		  3'd7 : CERES_Q = CERES_ON ? {24'd0,VECTOR_Q} : ICU_Q[31:0];
		endcase
		
	always @(posedge BCLK) if (W_DIPSW) dip_sw <= DIN;
	
	assign INT_N = CERES_ON ? GINT : ICU_Q[32];
	
endmodule
		