## Copyright (C) 1991-2008 Altera Corporation
## Your use of Altera Corporation's design tools, logic functions 
## and other software and tools, and its AMPP partner logic 
## functions, and any output files from any of the foregoing 
## (including device programming or simulation files), and any 
## associated documentation or information are expressly subject 
## to the terms and conditions of the Altera Program License 
## Subscription Agreement, Altera MegaCore Function License 
## Agreement, or other applicable license agreement, including, 
## without limitation, that your use is for the sole purpose of 
## programming logic devices manufactured by Altera and sold by 
## Altera or its authorized distributors.  Please refer to the 
## applicable agreement for further details.


## VENDOR  "Altera"
## PROGRAM "Quartus II"
## VERSION "Version 8.1 Build 163 10/28/2008 SJ Web Edition"

## DATE    "Mon Mar 08 15:49:34 2010"

##
## DEVICE  "EP4CE22F17C6"
##

#**************************************************************
# Time Information
#**************************************************************

set_time_format -unit ns -decimal_places 3

#**************************************************************
# Create Clock
#**************************************************************

create_clock -name {clock_ref}  -period 20.000 -waveform { 0.000 10.000 } [get_ports {RCLK}]

#**************************************************************
# Create Generated Clock
#**************************************************************

#derive_pll_clocks
#create_generated_clock -name {clock_4} -source [get_ports {CLK12}] -divide_by 3 -master_clock {clock_12} [get_registers {TEST_CONTROL:INSTAGE|takt[2]}] 
#	Info: Node: PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0] was found missing 1 generated clock that corresponds to a base clock with a period of: 67.819
#create_generated_clock -name {clock_} -source [get_ports {MCLK_IN}] -divide_by 50 -multiply_by 4 [get_registers {DRAM_IF|MPLL|altpll_component|pll|clk[0]}]
create_generated_clock -name {clock_bclk}  -source [get_ports {RCLK}]            -divide_by  1 -multiply_by  1 [get_pins {MPLL|mainpll_inst|altera_pll_i|outclk_wire[0]~CLKENA0|outclk}]
create_generated_clock -name {clock_mclk}  -source [get_ports {RCLK}]            -divide_by  1 -multiply_by  2 [get_pins {MPLL|mainpll_inst|altera_pll_i|outclk_wire[1]~CLKENA0|outclk}]
create_generated_clock -name {clock_mclkm} -source [get_ports {RCLK}] -phase  45 -divide_by  1 -multiply_by  2 [get_pins {MPLL|mainpll_inst|altera_pll_i|outclk_wire[2]~CLKENA0|outclk}]
create_generated_clock -name {clock_gclk}  -source [get_ports {RCLK}]            -divide_by  2 -multiply_by  3 [get_pins {MPLL|mainpll_inst|altera_pll_i|outclk_wire[3]~CLKENA0|outclk}]
#	Warning: Node: DRAM_IF|MPLL|altpll_component|pll|clk[0] was found missing 1 generated clock that corresponds to a base clock with a period of: 40.000

#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************

set_clock_uncertainty 0.1 -to clock_ref
set_clock_uncertainty 0.1 -to clock_bclk
set_clock_uncertainty 0.1 -to clock_mclk
set_clock_uncertainty 0.1 -to clock_mclkm
set_clock_uncertainty 0.1 -to clock_gclk

#set_clock_uncertainty 0.0ns -to PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0]

#**************************************************************
# Set Input Delay
# nur wenn die Werte sehr hoch sind (nahe der Periodendauer) gibt es Probleme bzw. Meldungen : bei 75
#**************************************************************

#set_input_delay -clock clock_4 -min 5 [get_ports {DX}]
#set_input_delay -clock clock_12 -min 5 [get_ports {RS_RX}]
#set_input_delay -clock clock_4   20 [get_ports {DX}]
#set_input_delay -clock clock_12  75 [get_ports {RS_RX}]
#set_input_delay -clock clock_sys  10 -clock_fall [get_ports {RD_N}]
#set_input_delay -clock clock_sys  10 [get_ports {WR_N AA*}]
#set_input_delay -clock clock_sys  10 [get_ports {AD[*}]
#set_input_delay -clock clock_sys  10 [get_ports {CTS_L CTS_R}]
# ALE fehlt daher keine Ausgabe bei Propagation Delay
#set_input_delay -clock PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0] 10 -clock_fall [get_ports {PCMTX_*}]

#**************************************************************
# Set Output Delay
# -clock_fall wird bei Signalen eingesetzt, die auf fallende Flanke rauskommen
#**************************************************************

#set_output_delay -clock clock_sys 10 -clock_fall [get_ports {AD[*}]
#set_output_delay -clock clock_sys 10 [get_ports {INT_* LED_N}]
#set_output_delay -clock clock_sys 10 [get_ports {DI_L AD_L CLK_L DI_R AD_R CLK_R}]
#set_output_delay -clock clock_sys 10 -clock_fall [get_ports {CS_L CS_R}]
     # Sonderfall wegen WR_N !
#set_output_delay -clock clock_sys  3 -clock_fall [get_ports {OE_N}]
#set_output_delay -clock clock_sys 10 -clock_fall [get_ports {DIR_RD}]

#set_output_delay -clock clock_sys												10 [get_ports {SEL*}]
#set_output_delay -clock PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0]	10 [get_ports {SEL*}]

# PCM Highway :
#set_output_delay -clock PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0]  10 [get_ports {RXSEL_* TXSEL_* FRAME_* PCMCLK_* PCMRX_*}]

# die folgenden Pins sind nur zur Analyse :
#set_output_delay -clock PCM_CLOCK|altpll_component|auto_generated|pll1|clk[0]  5 [get_ports {DOC_RD DOC_WR}]

#**************************************************************
# Set Clock Groups
#**************************************************************



#**************************************************************
# Set False Path
# Control Signale die von einer Clock-Domain auf eine andere uebergehen !
#**************************************************************

set_false_path -from clock_gclk -to clock_bclk
set_false_path -from clock_bclk -to clock_gclk

set_false_path -from [get_ports {SSW[*}]

#set_false_path -from [get_ports {STATUS*}]
#set_false_path -from [get_registers {CPU_IF:INTERFACE|DTC_REG*}]

#**************************************************************
# Set Multicycle Path
#**************************************************************

# das folgende gilt fuer BCLK => MCLK
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|MMU_VAL:MMU_VALID|altsyncram:altsyncram_component|altsyncram_44l1:auto_generated|ram_block1a0~porta_address_reg*}] 2

#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|MMU_VAL:MMU_VALID|altsyncram:altsyncram_component|*~porta_address_reg*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|MMU_VAL:MMU_VALID|altsyncram:altsyncram_component|*~porta_address_reg*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|MMU_VAL:MMU_VALID|altsyncram:altsyncram_component|*~porta_address_reg*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|MMU_VAL:MMU_VALID|altsyncram:altsyncram_component|*~porta_address_reg*}] 1 -hold

#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_DATA:DATASET_0|*}] 3
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_DATA:DATASET_1|*}] 3
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_DATA:DATASET_0|*}] 2 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_DATA:DATASET_1|*}] 2 -hold

#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_TAG:TAGSET_0|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_TAG:TAGSET_1|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_VAL:CA_VALID|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_TAG:TAGSET_0|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_TAG:TAGSET_1|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|DCACHE:ARME|CA_VAL:CA_VALID|*}] 1 -hold

#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_VAL:CA_VALID|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:TAGSET_0|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:TAGSET_1|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_VAL:KOL_VAL|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:KOL_TAG_0|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:KOL_TAG_1|*}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_VAL:CA_VALID|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:TAGSET_0|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:TAGSET_1|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_VAL:KOL_VAL|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:KOL_TAG_0|*}] 1 -hold
#set_multicycle_path -rise_from clock_bclk -to [get_registers {M32632:CPU|ICACHE:BEINE|CA_TAG:KOL_TAG_1|*}] 1 -hold

#set_multicycle_path -rise_from clock_bclk -to [get_registers {DRAMIF:DRAM_IF|DRAM_SM:SM_DRAM|dma_a[*]}] 2
#set_multicycle_path -rise_from clock_bclk -to [get_registers {DRAMIF:DRAM_IF|DRAM_SM:SM_DRAM|dma_a[*]}] 1 -hold

#set_multicycle_path -from [get_registers {*BEINE|MMU_RAM*}] -to [get_registers {*BEINE|MMU_VAL*}] 2
#set_multicycle_path -from [get_registers {*BEINE|MMU_RAM*}] -to [get_registers {*BEINE|MMU_VAL*}] 1 -hold
#set_multicycle_path -from [get_registers {*ARME|MMU_RAM*}] -to [get_registers {*ARME|MMU_VAL*}] 2
#set_multicycle_path -from [get_registers {*ARME|MMU_RAM*}] -to [get_registers {*ARME|MMU_VAL*}] 1 -hold

# Nur fuer TITAN4
#set_multicycle_path -from [get_registers {M32632:CPU|DCACHE:ARME|CDAT[*]}] -to [get_registers {DRAMIF:DRAM_IF|RDQ[*]}] 2
#set_multicycle_path -from [get_registers {M32632:CPU|DCACHE:ARME|CDAT[*]}] -to [get_registers {DRAMIF:DRAM_IF|RDQ[*]}] 1 -hold

#set_multicycle_path -from [get_registers {DRAMIF:DRAM_IF|DATAPATH:DP_DRAM|*}] -to [get_registers {DRAMIF:DRAM_IF|CPUL*}] 2
#set_multicycle_path -from [get_registers {DRAMIF:DRAM_IF|DATAPATH:DP_DRAM|DATABYTE:HBYTE|DATABYTE_dq_cqj:DATABYTE_dq_cqj_component|input_*}] 2

#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************

